unit KeyLib;

interface

type RegInfo=record
               ProdID,Serial:longword;
               Name:shortstring;
               Mail:shortstring;
             end;

const KS_Okay:byte=$00;
      KS_Illegal:byte=$01;
      KS_BlackListed:byte=$02;
      KS_NotFound:byte=$03;

function KS_GetRegInfo(filename:string; var reg:RegInfo; blist:pointer; blsiz:longword):byte;

implementation

function KS_GetRegInfo(filename:string; var reg:RegInfo; blist:pointer; blsiz:longword):byte;
type tba=array [0..0] of longword;
var f:file;
    BlackListNbr:^tba;
    l0,l1,l2,l3,l4,l5,l6,l7,l8,l9:longword;
    b0,b1,b2,b3:byte;
    BlackListed:boolean;
    Illegal:boolean;
    Checked:array[$00..$ff] of byte;
begin
  BlackListNbr:=blist;
  assign(f,filename);
  illegal:=FALSE;
 {$I-} reset(f,1); {$I+}
  if ioresult<>0 then KS_GetRegInfo:=KS_NotFound else begin
    if filesize(f)<>$200 then KS_GetRegInfo:=KS_Illegal else begin
      seek(f,$1f8); blockread(f,l0,$04);
      if l0 and $003b0000<>0 then illegal:=TRUE;
      blockread(f,l5,$04); reg.serial:=l5;
      l2:=0; l3:=0; l4:=0;
      for l1:=$96 downto $00 do begin
        seek(f,$33+l1*$03); blockread(f,l2,1); blockread(f,l3,1); blockread(f,l4,1);
        l0:=l0-l4 shl $18;
        l0:=l0 xor l2 xor l3 xor l4;
      end;
      reg.prodid:=l0 xor reg.serial;
      seek(f,$33); fillchar(checked,$100,$00); reg.name:=''; reg.mail:='';
      l2:=0; l3:=0; l4:=0; l8:=0;
      for l1:=$00 to $96 do begin
        blockread(f,l2,1); blockread(f,l3,1); blockread(f,l4,1);
        l8:=l8+l2*l3+l2 xor l8+l3 xor l8+l2*l3*l8;
        l2:=l2 xor l4; l3:=l3 xor l4;
        if (Checked[l4]=$01) or (l4 and $09=$01) then illegal:=TRUE else checked[l4]:=$01;
        reg.name:=reg.name+chr(l2);
        reg.mail:=reg.mail+chr(l3);
      end;
      l0:=0;
      while ((byte(reg.name[1])<>(byte(reg.name[1+l0])-1)) or
             (byte(reg.name[2])<>(byte(reg.name[2+l0])-1)) or
             (byte(reg.name[3])<>(byte(reg.name[3+l0])-1)) or
             (byte(reg.name[4])<>(byte(reg.name[4+l0])-1))) and (l0<$40) do inc(l0);
      if l0=$40 then illegal:=TRUE else reg.name[0]:=chr(l0);
      l0:=0;
      while ((byte(reg.mail[1])<>(byte(reg.mail[1+l0])-1)) or
             (byte(reg.mail[2])<>(byte(reg.mail[2+l0])-1)) or
             (byte(reg.mail[3])<>(byte(reg.mail[3+l0])-1)) or
             (byte(reg.mail[4])<>(byte(reg.mail[4+l0])-1))) and (l0<$40) do inc(l0);
      if l0=$40 then illegal:=TRUE else reg.mail[0]:=chr(l0);
      blacklisted:=FALSE;
      if blsiz>0 then for l9:=0 to blsiz-1 div 4 do if blacklistnbr^[l9]=l8 then blacklisted:=TRUE;
      if illegal then KS_GetRegInfo:=KS_Illegal else
      if blacklisted then KS_GetRegInfo:=KS_BlackListed else
      KS_GetRegInfo:=KS_Okay;
    end;
    close(f);
  end;
end;

end.